// Generated by CoffeeScript 1.6.3
var checkModified, exec, fs, path;

exec = require('executive');

fs = require('fs');

path = require('path');

checkModified = function(src, dst, cb) {
  return fs.stat(src, function(err, stat) {
    var mtime;
    if (err) {
      return cb(err);
    }
    mtime = stat.mtime;
    return fs.stat(dst, function(err, stat) {
      if (err) {
        return cb(err);
      }
      return cb(mtime > stat.mtime);
    });
  });
};

module.exports = {
  compilers: {
    coffee: function(src, dst) {
      dst = path.dirname(dst);
      return "coffee -bc -o " + dst + " " + src;
    },
    jade: function(src, dst) {
      dst = path.dirname(dst);
      return "jade " + src + " --out " + dst;
    },
    styl: function(src, dst) {
      dst = path.dirname(dst);
      return "stylus " + src + " -o " + dst;
    }
  },
  mappings: {
    coffee: 'js',
    jade: 'html',
    styl: 'css'
  },
  compile: function(opts) {
    var compiler, compilers, dst, ext, k, mappings, src, v, _ref, _ref1, _ref2, _ref3;
    src = opts[0], dst = opts[1];
    compilers = {};
    mappings = {};
    _ref = this.mappings;
    for (k in _ref) {
      v = _ref[k];
      mappings[k] = v;
    }
    _ref1 = this.compilers;
    for (k in _ref1) {
      v = _ref1[k];
      compilers[k] = v;
    }
    _ref2 = opts.mappings;
    for (k in _ref2) {
      v = _ref2[k];
      mappings[k] = v;
    }
    _ref3 = opts.compilers;
    for (k in _ref3) {
      v = _ref3[k];
      compilers[k] = v;
    }
    ext = (path.extname(src)).substr(1);
    if ((compiler = this[ext]) == null) {
      return false;
    }
    if (dst == null) {
      dst = src.replace(new RegExp(ext + '$'), this.mappings[ext]);
    }
    checkModified(src, dst, function(newer) {
      var cmd;
      if (!newer) {
        return;
      }
      if (typeof (cmd = compiler(src, dst)) === 'string') {
        return exec.quiet(cmd, function(err, stdout, stderr) {
          if ((stderr = stderr.trim()) !== '') {
            return console.error(stderr);
          }
        });
      }
    });
    return true;
  }
};

/*
//@ sourceMappingURL=compile.map
*/
