// Generated by CoffeeScript 1.6.3
var fs, injectJs, serveJs;

fs = require('fs');

injectJs = function(res) {
  var appendScript, end, setHeader;
  appendScript = false;
  end = res.end;
  setHeader = res.setHeader;
  res.setHeader = function(name, value) {
    if (/text\/html/i.test(value)) {
      appendScript = true;
    } else if (name === 'Content-Length' && appendScript) {
      value = parseInt(value, 10) + 34;
    }
    return setHeader.call(res, name, value);
  };
  return res.end = function(chunk, encoding) {
    if (appendScript) {
      res.write('<script src="_bebop.js"></script>\n', encoding);
    }
    return end.call(res, chunk, encoding);
  };
};

serveJs = function(res) {
  res.writeHead(200, {
    'Content-Type': 'application/javascript'
  });
  return fs.createReadStream(__dirname + '/client.js').pipe(res);
};

module.exports = function(options) {
  var app, patch, url;
  if (typeof options === 'function') {
    options = {
      app: options
    };
  } else {
    if (options == null) {
      options = {};
    }
  }
  if (options.url == null) {
    options.url = '/_bebop.js';
  }
  app = options.app;
  patch = options.patch;
  url = options.url;
  return function(req, res, next) {
    if (req.url === url) {
      return serveJs(res);
    }
    if (patch || app) {
      injectJs(res);
    }
    if (typeof app === 'function') {
      app(req, res);
    }
    if (typeof next === 'function') {
      return next();
    }
  };
};

/*
//@ sourceMappingURL=middleware.map
*/
