// Generated by CoffeeScript 1.6.3
module.exports = function(server) {
  var WebSocketServer, clients, id, wss;
  WebSocketServer = require('ws').Server;
  wss = new WebSocketServer({
    server: server,
    path: '/_bebop'
  });
  clients = {};
  id = 0;
  wss.on('connection', function(ws) {
    id += 1;
    ws.id = id;
    clients[ws.id] = ws;
    return ws.on('close', function() {
      return delete clients[ws.id];
    });
  });
  return {
    server: wss,
    close: function() {
      for (id in clients) {
        clients[id].close();
        delete clients[id];
      }
      return wss.close();
    },
    send: function(message) {
      var err, _results;
      _results = [];
      for (id in clients) {
        try {
          _results.push(clients[id].send(JSON.stringify(message)));
        } catch (_error) {
          err = _error;
          _results.push(console.error(err.stack));
        }
      }
      return _results;
    }
  };
};

/*
//@ sourceMappingURL=websocket.map
*/
